<?php

/**

 * Pimcore

 *

 * LICENSE

 *

 * This source file is subject to the new BSD license that is bundled

 * with this package in the file LICENSE.txt.

 * It is also available through the world-wide-web at this URL:

 * http://www.pimcore.org/license

 *

 * @category   Pimcore

 * @package    Document

 * @copyright  Copyright (c) 2009-2014 pimcore GmbH (http://www.pimcore.org)

 * @license    http://www.pimcore.org/license     New BSD License

 */



namespace Pimcore\Model\Document\Tag\Area;



use Pimcore\Model;



class Info {



    /**

     * @var Model\Document\Tag

     */

    public $tag;



    /**

     * @var string

     */

    public $name;



    /**

     * @var \Zend_Config

     */

    public $config;



    /**

     * @var string

     */

    public $id;



    /**

     * @var int

     */

    public $index;



    /**

     * @var string

     */

    public $path;





    /**

     * @param \Zend_Config $config

     * @return $this

     */

    public function setConfig($config)

    {

        $this->config = $config;

        return $this;

    }



    /**

     * @return \Zend_Config

     */

    public function getConfig()

    {

        return $this->config;

    }



    /**

     * @param string $id

     * @return $this

     */

    public function setId($id)

    {

        $this->id = $id;

        return $this;

    }



    /**

     * @return string

     */

    public function getId()

    {

        return $this->id;

    }



    /**

     * @param int $index

     * @return $this

     */

    public function setIndex($index)

    {

        $this->index = $index;

        return $this;

    }



    /**

     * @return int

     */

    public function getIndex()

    {

        return $this->index;

    }



    /**

     * @param string $path

     * @return $this

     */

    public function setPath($path)

    {

        $this->path = $path;

        return $this;

    }



    /**

     * @return string

     */

    public function getPath()

    {

        return $this->path;

    }



    /**

     * @param string $name

     */

    public function setName($name)

    {

        $this->name = $name;

    }



    /**

     * @return string

     */

    public function getName()

    {

        return $this->name;

    }



    /**

     * @return Model\Document\Tag

     */

    public function getTag()

    {

        return $this->tag;

    }



    /**

     * @param Model\Document\Tag $tag

     */

    public function setTag($tag)

    {

        $this->tag = $tag;

    }

}

    