<?php

/**

 * Pimcore

 *

 * LICENSE

 *

 * This source file is subject to the new BSD license that is bundled

 * with this package in the file LICENSE.txt.

 * It is also available through the world-wide-web at this URL:

 * http://www.pimcore.org/license

 *

 * @category   Pimcore

 * @package    Element

 * @copyright  Copyright (c) 2009-2014 pimcore GmbH (http://www.pimcore.org)

 * @license    http://www.pimcore.org/license     New BSD License

 */



namespace Pimcore\Model\Element\Reference;



use Pimcore\Model;



class Placeholder {



    /**

     * @var int

     */

    public $id;



    /**

     * @var string

     */

    public $type;



    /**

     * @param int $id

     * @param string $type

     */

    public function __construct($id, $type) {

        $this->setId($id);

        $this->setType($type);

    }



    /**

     * @param int $id

     * @return void

     */

    public function setId($id)

    {

        $this->id = (int) $id;

        return $this;

    }



    /**

     * @return int

     */

    public function getId()

    {

        return $this->id;

    }



    /**

     * @param string $type

     * @return void

     */

    public function setType($type)

    {

        $this->type = $type;

        return $this;

    }



    /**

     * @return string

     */

    public function getType()

    {

        return $this->type;

    }

}

