<?php

/**

 * Pimcore

 *

 * LICENSE

 *

 * This source file is subject to the new BSD license that is bundled

 * with this package in the file LICENSE.txt.

 * It is also available through the world-wide-web at this URL:

 * http://www.pimcore.org/license

 *

 * @category   Pimcore

 * @package    Staticroute

 * @copyright  Copyright (c) 2009-2014 pimcore GmbH (http://www.pimcore.org)

 * @license    http://www.pimcore.org/license     New BSD License

 */



namespace Pimcore\Model\Staticroute\Listing;



use Pimcore\Model;



class Resource extends Model\Listing\Resource\AbstractResource {



    /**

     * Loads a list of static routes for the specicifies parameters, returns an array of Staticroute elements

     *

     * @return array

     */

    public function load() {



        $routesData = $this->db->fetchCol("SELECT id FROM staticroutes" . $this->getCondition() . $this->getOrder() . $this->getOffsetLimit(), $this->model->getConditionVariables());



        $routes = array();

        foreach ($routesData as $routeData) {

            $routes[] = Model\Staticroute::getById($routeData);

        }



        $this->model->setRoutes($routes);

        return $routes;

    }



    /**

     * @return int

     */

    public function getTotalCount() {



        try {

            $amount = (int) $this->db->fetchOne("SELECT COUNT(*) as amount FROM staticroutes " . $this->getCondition(), $this->model->getConditionVariables());

        } catch (\Exception $e) {



        }



        return $amount;

    }



}

