<?php

use Website\Controller\Action;

class CronController extends Action
{
    public function updateCommentsAction()
    {

        define('CR',"<br>");
        define('CALL_PER_HOUR', 9);
        define('DELAY', 360); // 6min


        $i = $this->getParam('index');
        if (is_null($i)) { echo ('index is mandatory'); return; }
        if ($i >= CALL_PER_HOUR){ echo 'index overflow (max : ' . CALL_PER_HOUR . ' )'; return; }

        $agenciesToUpdate = array();

        foreach (Website\Model\Agency::searchGlobal(array('seerus_secret IS NOT NULL', 'seerus_secret != ""')) as $a){
            /* @var \Website\Model\Agency $a */
            $agenciesToUpdate[$a->getSeerus_secret()] = $a;
        }

        $nb_survey_per_call = ceil(count($agenciesToUpdate) / CALL_PER_HOUR);
        $secretKeysArr = array_slice(array_keys($agenciesToUpdate),$i * $nb_survey_per_call, $nb_survey_per_call);
        $params = (object)array('surveys' => (object)$secretKeysArr);


        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, 'http://www.seerus.com/ws/survey/multi/results/export');
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_POST, true);
        curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($params));
        $response = curl_exec($curl);
        curl_close($curl);
        $json = json_decode($response);


        $k = 0;
        if ($json->success){

            foreach ($json->urls as $secret => $url){
                /* @var \Website\Model\Agency $currentAgency */
                $currentAgency = $agenciesToUpdate[$secret];

                if ($currentAgency instanceof \Website\Model\Agency) {
                    try{
                        echo trim($currentAgency->getName()) . ' [ ' .$secret . ' ] [';

                        $tmpFileName = $_SERVER['DOCUMENT_ROOT'] . "/tmp/" . $currentAgency->getSeerus_secret() ;
                        file_put_contents($tmpFileName, fopen($url, 'r'));
                        $currentAgency->updateCommentFromFile($tmpFileName);
                        chmod($tmpFileName, 0777);
                    }catch(\Exception $e){
                        echo ' ERROR : ' . $e . ']' . CR;
                    }
                    try{
                        unlink($tmpFileName);
                    }catch(\Exception $e){}



                }

                $k ++;
            }
        }
        else{
            echo $json->error;
        }
    }


    private function downloadCsv($secret){

    }
    
}