<?php



namespace Website\Tool;



class RealAdvice

{

    public static function writeOpeningHours($amStart, $amEnd, $pmStart, $pmEnd){

        $ret = '';



        if (is_null($amStart)) return 'non comuniqué';



        if ($amStart == '0'){

            if($pmEnd == '0')

                return 'fermé';

            else

                return self::checkPm($pmStart,$pmEnd);

        }



        if ($amStart == '-1'){

            if ($pmEnd == '-1')

                return 'sur rdv';

            else

                return 'matin sur rdv, ' . self::checkPm($pmStart,$pmEnd);

        }



        if ($amEnd == -3) return $amStart . ' - ' . $pmEnd;



        return $amStart.' - '.$amEnd . '  ' .  self::checkPm($pmStart,$pmEnd);



    }



    private static function checkPm($pmStart, $pmEnd ){

        if($pmStart == '-1') return 'après-midi sur rdv';



        if($pmStart == '0') return '';



        return $pmStart . ' - ' .$pmEnd;

    }



    public static function isNowOpen($openingHours){

        switch(date('N')){

            case 1 : break;

            case 2 : break;

            case 3 : break;

            case 4 : break;

            case 5 : break;

            case 6 : break;

            case 7 : break;

        }



        return -1;

    }



    /**

     * @param \Website\Model\Agency $agency

     * @return string

     */

    public static function getWidget($agency, $view){

        $key = $agency->getSeerus_key();



        if($key == ''){

            return '<div class="no-widget"><span>'. $view->t('widget-not-available').'</span><img src="/website/views/layouts/images/widget-indisponible.png" alt=""/></div>';

        }else{

            switch($view->lang){

                case 'fr' : $baseUrl = 'http://www.seerus.com/fr/etude/widget/nps/'; break;

                case 'nl' : $baseUrl = 'http://www.seerus.com/nl/marktonderzoek/widget/nps/'; break;

                default   : $baseUrl = '';

            }

            try{

                $widget = file_get_contents($baseUrl . $key);

            }catch (\Exception $e){

                return '<div class="no-widget"><img src="/website/views/layouts/images/widget-indisponible.png" alt=""/></div>';

            }







            $re = "/<div id=\"seerus-nps-main\".*<div class=\"clear\"><\\/div>/s";



            preg_match($re, $widget, $matches);





            $re = '/<div class=\"seerus-nps-quote\">[^\\/]*/s';



            preg_match($re, $widget, $quote);

            $agency->setNps(((float)trim(substr($quote[0], 30)))/2);

            $agency->save();



            if (count($matches))

                return $matches[0];

            else

                return '<span class="widget-error"><img src="/website/views/layouts/images/widget-indisponible.png" alt=""/></span>';

        }

    }



    public static function getUrl($website){

        if(substr($website,0,6)=='http://')

            return $website;

        else

            return 'http://'.$website;

    }



    public static function generateUid(){

        return str_replace('.','',uniqid('',true));

    }



    public static function isFromBelgium(){

        return strpos(strtolower( $_SERVER['SERVER_NAME']), '.be');

    }



    public static function isFromFrance(){

        return strpos(strtolower( $_SERVER['SERVER_NAME']), '.fr');

    }



}