<?php
$agency = $this->agency;

$this->headTitle('RealAdvice | ' . $agency->getName() . ' | Comments');
$this->headLink()->appendStylesheet('/website/views/layouts/css/nps.css');
$this->headScript()->appendFile('https://maps.googleapis.com/maps/api/js?sensor=false&language=fr');
$this->headScript()->appendFile('https://maps.googleapis.com/maps/api/js?sensor=false&language=fr');
$this->headScript()->appendFile('/pimcore/static/css/fontello.css');

$this->append
?>

<div id="fb-root"></div>
<script>(function(d, s, id) {
        var js, fjs = d.getElementsByTagName(s)[0];
        if (d.getElementById(id)) return;
        js = d.createElement(s); js.id = id;
        js.src = "//connect.facebook.net/fr_FR/sdk.js#xfbml=1&version=v2.5&appId=1476466219304155";
        fjs.parentNode.insertBefore(js, fjs);
    }(document, 'script', 'facebook-jssdk'));
</script>

<div class="comment-report">
    <div class="report-header">
        <div class="container">
            <div class="header-block agency-logo">
                <img src="<?=$agency->getLogoUrl() ?>" alt="">
            </div>
            <div class="coord header-block">
                <table>
                    <?php if($agency->getAddress() != '') { ?>
                        <tr>
                            <td><i class="icon-home"></i></td>
                            <td id="address"><?= $agency->getAddress() ?><br><?= $agency->getCp() ?> <?= $agency->getCity() ?></td>
                        </tr>
                    <?php } if($agency->getPhone() != "") { ?>
                    <tr>
                        <td><i class="icon-phone"></i></td>
                        <td><?= $agency->getPhone() ?></td>
                    </tr>
                    <?php } if($agency->getEmail() != "") { ?>
                    <tr>
                        <td><i class="icon-mail"></i></td>
                        <td><?= $agency->getEmail() ?></td>
                    </tr>
                    <?php } if($agency->getWebsite() != "") { ?>
                    <tr>
                        <td><i class="icon-globe"></i></td>
                        <td><a target="_blank" href="<?= $agency->getWebsite() ?>">Website</a></td>
                    </tr>
                    <?php } ?>
                </table><!--

            --><div class="widget"><?= \Website\Tool\RealAdvice::getWidget($agency) ?></div>

            </div>

            <hr>
            <h2 itemprop="name"><?= $agency->getName() ?></h2>
            <div class="rating"><?= $this->partial('/public/partial/fancy-stars.php', array("quote" => $agency->getNps()*2)) ?></div>
            <div class="social">
                <?php if(!is_null($agency->getFacebook()) && $agency->getFacebook() != "" ){
                    echo '<div class="fb-share-button" data-href="'. $agency->getFacebook() .'" data-layout="button"></div>'  ;
                    echo '<div class="fb-like" data-href="'. $agency->getFacebook() .'" data-show-faces="false" data-layout="button"></div>';
                } ?>

                <?php if(!is_null($agency->getLinkedin()) && $agency->getLinkedin() != "" ){
                    echo '<script src="//platform.linkedin.com/in.js" type="text/javascript"> lang: fr_FR</script>';
                    echo '<script type="IN/Share" data-url="'. $agency->getLinkedin() .'"></script>';
                }?>

                <?php if(!is_null($agency->getTwitter()) && $agency->getTwitter() != "" ){ ?>
                    <a href="<?= $agency->getTwitter() ?>" class="twitter-follow-button" data-show-count="false" data-show-screen-name="false">Follow</a>
                    <script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?'http':'https';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+'://platform.twitter.com/widgets.js';fjs.parentNode.insertBefore(js,fjs);}}(document, 'script', 'twitter-wjs');</script>
                <?php }?>
            </div>

            <div class="v-spacer"></div>
            <p class="description"  itemprop="description" ><?= $agency->getLong_description() ?></p>
            <a href="#" class="bt cta icon-phone" id="cta">Etre recontacté par l'agence</a>

            <hr>

            <div class="opening-hours">
                <div class="title icon-clock">heures d'ouverture</div>
                <div class="part1"><?= $this->partial('/public/partial/opening-hours.php', array('agency' => $agency, 'days' => array('monday','thuesday' , 'wednesday' ,'thursday'))) ?></div>
                <div class="part2"><?= $this->partial('/public/partial/opening-hours.php', array('agency' => $agency, 'days' => array('friday','saturday' , 'sunday'))) ?></div>
            </div>

        </div>
    </div>

    <div class="comment-box container">

        <div class="certification">
            <img src="/website/views/layouts/images/certification.png" alt="">
            <p>Cette entreprise respecte la charte Seerus sur la récolte et la restitution d'avis. Pour consulter cette charte, cliquez ici</p>
        </div>

        <hr class="clear">

        <div class="comment-box-header">

            <div class="filter">
                <?php
                    $filters = array("positive" => 0, "negative" => 0, "neutral" => 0);
                    foreach ($agency->getComments() as $c){
                        if ($c->getQuote() < 5) $filters["negative"] += 1;
                        elseif ($c->getQuote() > 7) $filters["positive"] += 1;
                        else $filters["neutral"] += 1;
                    }
                ?>
                <span class="filter negative"><i class="icon-frown"></i><span><?= $filters["negative"] ?>  avis négatif<?= ($filters["negative"] > 2)?'s':'' ?></span></span>
                <span class="filter neutral"><i class="icon-meh"></i><span><?= $filters["neutral"] ?>  avis non classé<?= ($filters["neutral"] > 2)?'s':'' ?></span></span>
                <span class="filter positive"><i class="icon-smile"></i><span><?= $filters["positive"] ?> avis positif<?= ($filters["positive"] > 2)?'s':'' ?></span></span>
            </div>
            <h2>avis clients</h2>
            <div class="v-spacer"></div>
        </div>
        <!--<table class="comments">-->

            <?php foreach($agency->getComments() as $c) {
                $mood = ($c->getQuote() > 7) ? 'positive' : (($c->getQuote() < 5) ? 'negative' : 'neutral');
            ?>

                <div class="comment <?= $mood ?>">

                    <div class="comment-header"><span class="date"><?= Date('d/m/Y', $c->getDate()) ?></span></div>
                    <div class="comment-body">
                        <img src="/website/views/layouts/images/profil.png" alt="">
                        <div class="quote"><?= $this->partial('/public/partial/fancy-stars.php', array('quote' => ($c->getQuote()))) ?></div>
                        <div class="texte"><?= $c->getText() ?></div>
                        <div class="clear"></div>
                    </div>
                </div>


            <?php } ?>

        <div id="map"></div>
    </div>
</div>



<?= $this->partial('/public/partial/schema.php', array("agency" => $agency)) ?>


<script type="text/javascript">
    var geocoder;
    var map;
    // initialisation de la carte Google Map de départ
    function initialiserCarte() {
        geocoder = new google.maps.Geocoder();
        // Ici j'ai mis la latitude et longitude du vieux Port de Marseille pour centrer la carte de départ
        var latlng = new google.maps.LatLng(50.6375022,4.6626637);
        var mapOptions = {
            zoom      : 7,
            center    : latlng,
            mapTypeId : google.maps.MapTypeId.ROADMAP
        }
        // map-canvas est le conteneur HTML de la carte Google Map
        map = new google.maps.Map(document.getElementById('map'), mapOptions);
        TrouverAdresse();
    };

    function TrouverAdresse() {
        // Récupération de l'adresse tapée dans le formulaire
        var adresse = $('#address').html().replace('<br>', ' ');
        geocoder.geocode( { 'address': adresse}, function(results, status) {
            if (status == google.maps.GeocoderStatus.OK) {
                map.setCenter(results[0].geometry.location);
                map.setZoom(14);
                // Création du marqueur du lieu (épingle)
                var marker = new google.maps.Marker({
                    map: map,
                    position: results[0].geometry.location
                });
            } else {
                document.getElementById('map').style.display = 'none' ;
            }
        });
    }
    // Lancement de la construction de la carte google map
    google.maps.event.addDomListener(window, 'load', initialiserCarte);

</script>

<script>
    $('.filter').click(function(){
        if( $(this).hasClass('positive') ) {
            $('.comment.positive').show();
            $('.comment.negative').hide();
            $('.comment.neutral').hide();
        }else if( $(this).hasClass('neutral') ){
            $('.comment.neutral').show();
            $('.comment.negative').hide();
            $('.comment.positive').hide();
        }else if( $(this).hasClass('negative') ){
            $('.comment.negative').show();
            $('.comment.neutral').hide();
            $('.comment.positive').hide();
        }
    });
</script>