<?php

    use \Website\Tool\RealAdvice;



    $agency = $this->agency;



    if ($agency->getAddress()){

        $this->headScript()->appendFile('http://maps.google.com/maps/api/js?sensor=false');

        $this->headScript()->appendFile('/website/views/layouts/js/map.js');

    }



    if ($agency->getSeerus_key()){

        $this->headLink()->appendStylesheet('/website/views/layouts/css/nps.css');

    }



    $this->headTitle('RealAdvice | ' . $agency->getName());

    $this->headMeta()->setProperty('og:title', $agency->getName());

    $this->headMeta()->setProperty('og:type', 'website');

    $this->headMeta()->setProperty('og:site_name', 'RealAdvice');

    $this->headMeta()->setProperty('og:url', 'http://www.realadvice.be/agency/' . $agency->getUid() . '/' );

    $this->headMeta()->setProperty('og:image', 'http://www.realadvice.be' . $agency->getLogoUrl() );

    $this->headMeta()->setProperty('og:description', str_replace('<br>', ' ', $agency->getLong_description()));



?>





<div class="detail-wrapper clear">

    <div class="container">



        <div class="half-left">

            <h3><?= $agency->getName() ?></h3>

            <?php if(!is_null($agency->getSeerus_key()) && $agency->getSeerus_key() != '') { ?>

                <div class="stars pull-left"><?= $this->partial('/public/partial/stars.php', array('quote'=>$agency->getNps())) ?></div>

            <?php } ?>

        </div>

        <div class="half-right">

            <ul class="socials">

                <?php if ($agency->getWebsite() != ''){ ?>  <li><a href="<?= $agency->getWebsite() ?>"  target="_blank"><img src="/website/views/layouts/images/website-icon.png" alt="website"/></a></li><?php } ?>

                <?php if ($agency->getFacebook() != ''){ ?> <li><a href="<?= $agency->getFacebook() ?>" target="_blank"><img src="/website/views/layouts/images/facebook-icon.png" alt="facebok"/></a></li><?php } ?>

                <?php if ($agency->getTwitter() != ''){ ?>  <li><a href="<?= $agency->getTwitter() ?>"  target="_blank"><img src="/website/views/layouts/images/twitter-icon.png" alt="twitter"/></a></li><?php } ?>

                <?php if ($agency->getLinkedin() != ''){ ?> <li><a href="<?= $agency->getLinkedin() ?>" target="_blank"><img src="/website/views/layouts/images/linkedin-icon.png" alt="linkedin"/></a></li><?php } ?>

            </ul>

        </div>



        <hr class="clear"/>



        <div class="side pull-left">

            <div class="picture" style="background-image: url('<?= $agency->getLogoUrl() ?>')"></div>



            <div class="coordonnees">

                <?php

                    if($agency->getWebsite()!='' || $this->editmode ) echo '<p class="icon-home website"><a href="'. $agency->getWebsite() .'" target="_blank">'. $this->input("site-web") .'</a></p>';

                    if($agency->getPhone()  !='') echo '<p class="icon-phone phone">'. $agency->getPhone() .'</p>';

                    if($agency->getEmail()  !='') echo '<p class="icon-mail mail">'. $agency->getEmail() .'</p>';

                if ($agency->getAddress() != ''){

                    $city = ( is_null($agency->getCity()) || $agency->getCity() == "") ? $agency->getLocalite() : $agency->getCity();

                    echo '<div class="address icon-location pull-icon">'. $agency->getAddress() .'<br>' . $agency->getCp() . ' '  . $city . '</div>';

                }

                ?>

            </div>



            <div class="horraire">

                <h4><?= $this->input('heures-ouverture') ?></h4>

                    <?php

                        switch (RealAdvice::isNowOpen($agency->openingsHours())){

                            case 1  : echo '<div class="is-open"><span class="open">Ouvert</span> en ce moment</div>'; break;

                            case 0 : echo '<div class="is-open"><span class="closed">Fermé</span> en ce moment</div>'; break;

                            default :'';

                        };

                    ?>





                <table>

                    <tr>

                        <th><?= $this->input('lundi') ?></th>

                        <td><?= RealAdvice::writeOpeningHours($agency->getMonday_am_start(), $agency->getMonday_am_end(), $agency->getMonday_pm_start(), $agency->getMonday_pm_end()); ?></td>

                    </tr>

                    <tr>

                        <th><?= $this->input('mardi') ?></th>

                        <td> <?= RealAdvice::writeOpeningHours($agency->getThuesday_am_start(), $agency->getThuesday_am_end(), $agency->getThuesday_pm_start(), $agency->getThuesday_pm_end()); ?></td>

                    </tr>

                    <tr>

                        <th><?= $this->input('mercredi') ?></th>

                        <td><?= RealAdvice::writeOpeningHours($agency->getWednesday_am_start(), $agency->getWednesday_am_end(), $agency->getWednesday_pm_start(), $agency->getWednesday_pm_end()); ?></td>

                    </tr>

                    <tr>

                        <th><?= $this->input('jeudi') ?></th>

                        <td><?= RealAdvice::writeOpeningHours($agency->getThursday_am_start(), $agency->getThursday_am_end(), $agency->getThursday_pm_start(), $agency->getThursday_pm_end()); ?></td>

                    </tr>

                    <tr>

                        <th><?= $this->input('vendredi') ?></th>

                        <td><?= RealAdvice::writeOpeningHours($agency->getFriday_am_start(), $agency->getFriday_am_end(), $agency->getFriday_pm_start(), $agency->getFriday_pm_end()); ?></td>

                    </tr>

                    <tr>

                        <th><?= $this->input('samedi') ?></th>

                        <td><?= RealAdvice::writeOpeningHours($agency->getSaturday_am_start(), $agency->getSaturday_am_end(), $agency->getSaturday_pm_start(), $agency->getSaturday_pm_end()); ?></td>

                    </tr>

                    <tr>

                        <th><?= $this->input('dimanche') ?></th>

                        <td><?= RealAdvice::writeOpeningHours($agency->getSunday_am_start(), $agency->getSunday_am_end(), $agency->getSunday_pm_start(), $agency->getSunday_pm_end()); ?></td>

                    </tr>

                </table>

<!--                <div class="day lundi"><strong></strong> </div>

                <div class="day mardi"><strong></strong></div>

                <div class="day mercredi"><strong></strong> </div>

                <div class="day jeudi"><strong></strong> </div>

                <div class="day vendredi"><strong></strong> </div>

                <div class="day samedi"><strong></strong> </div>

                <div class="day dimanche"><strong></strong></div>-->

            </div>





           <!-- <a href="" class="contact-bt">Etre recontacté</a>-->



        </div>



        <div class="main pull-left">

            <div class="description">

                <p class="short-description"><?= $agency->getShort_description() ?></p>

                <p class="long-description"><?= nl2br($agency->getLong_description()) ?></div>



            <h5><?= $this->input('widget') ?></h5>



            <hr/>



            <div class="widget">

                <div class="iframe">

                    <a href="/fr/comments?uid=<?= $agency->getUid() ?>"><?= RealAdvice::getWidget($agency)?></a>

                </div>

                <?php

                    if($agency->getWebsite != '') echo '<a href="'. $agency->getWebsite() .'" target="_blank" class="button consult">Je consulte les biens de cette agence</a>';

                    if($agency->getSeerus_key()!='' && 0) echo '<a href="#" target="_blank" class="button comments">' . $this->input('temoignages-anciens-clients'). '</a>';

                ?>



            </div>

        </div>



    </div>



    <div class="clear"></div>



    <?php if($agency->getAddress() != '')

        echo '<div id="map_canvas" class="map container" data-address="'.$agency->getAddress() .' ' . $agency->getCp() .' Belgium"></div>';

    ?>



</div>



<div class="contact off">

    <div class="overlay"></div>

    <div class="iframe">

        <span class="close-iframe">X</span>

        <iframe src="/iframe/ctc-agcy?id=<?= $agency->getUid() ?>" frameborder="0"></iframe>

    </div>

</div>



<script>

    $('.contact-bt').click(function(e){

        $('.contact').removeClass('off').addClass('on');

        e.preventDefault();

    });



    $('.close-iframe').click(function(e){

        $('.contact').removeClass('on').addClass('off');

        e.preventDefault();

    });

</script>

